%define tarversion   2_8_0

%define major        28

%define libname      %mklibname xerces-c %major
%define libdev       %mklibname xerces-c %major -d

%define enable_debug 0
%{?_enable_debug: %{expand: %%global enable_debug 1}}

Name:           xerces-c%major
Epoch:          1
Version:        2.8.0
Release:        %mkrel 21
Summary:        Xerces-C++ validating XML parser
Group:          System/Libraries
URL:            https://xml.apache.org/xerces-c/
License:        Apache
Source0:        https://archive.apache.org/dist/xerces/c/2/sources/xerces-c-src_%{tarversion}.tar.gz
Patch0:         xerces-c-lib64.patch
# Most of apps
Patch1:         xerces-c-pvtheader.patch
# XQilla patches
Patch2:         xercesc_content_type.patch
Patch3:         xercesc_regex.patch
Patch4:         xerces-c-2.8.x-CVE-2009-1885.diff
BuildRequires:  pkgconfig(zlib)
BuildRequires:  pkgconfig(icu-i18n)

%description
Xerces-C++ is a validating XML parser written in a portable subset of C++.
Xerces-C++ makes it easy to give your application the ability to read and
write XML data. A shared library is provided for parsing, generating,
manipulating, and validating XML documents.

The parser provides high performance, modularity, and scalability. Source
code, samples and API documentation are provided with the parser. For
portability, care has been taken to make minimal use of templates, no RTTI,
and minimal use of #ifdefs.


#----------------------------------------------------------------------

%package -n     %libname
Summary:        Xerces-c library
Group:          System/Libraries

%description -n %libname
xerces-c library

%files -n %libname
%doc LICENSE.txt
%_libdir/libxerces-*.so.%{major}{,.*}

#----------------------------------------------------------------------

%package -n     %libdev
Summary:        Header files for Xerces-C++ validating XML parser
Group:          Development/C
Requires:       %libname = %epoch:%version-%release
Provides:       xerces-c%major-devel = %epoch:%version-%release
Conflicts:      %{mklibname xerces-c 0 -d}
Conflicts:      %{mklibname xerces-c 3.0 -d}

%description -n %libdev
Header files you can use to develop XML applications with Xerces-C++.

Xerces-C++ is a validating XML parser written in a portable subset of C++.
Xerces-C++ makes it easy to give your application the ability to read and
write XML data. A shared library is provided for parsing, generating,
manipulating, and validating XML documents.

%files -n %libdev
%_libdir/libxerces-c.so
%_libdir/libxerces-depdom.so
%_includedir/xercesc

#----------------------------------------------------------------------

%prep
%setup -q -n xerces-c-src_%{tarversion}
%if "%{_lib}" != "lib"
%patch -P 0 -p1 -b .orig
%endif
%patch -P 1 -p1
%patch -P 2 -p1
%patch -P 3 -p1
%patch -P 4 -p0 -b .CVE-2009-1885

# fix build on aarch64
for d in $(find . -name "config.sub");do
 cp -af %{_rpmconfigdir}/%{_real_vendor}/config.{guess,sub} $(dirname $d)
done

%build
%set_build_flags
export XERCESCROOT=%_builddir/xerces-c-src_%{tarversion}

cd $XERCESCROOT/src/xercesc
./runConfigure \
	-plinux \
	-cgcc \
	-xg++ \
	-minmem \
	-nsocket \
	-tnative \
	-rpthreads \
%if %{enable_debug}
	-d \
%endif
%if "%{_lib}" != "lib"
	-b "64" \
%else
	-b "32" \
%endif
	-P %_prefix \
	-C --libdir=%_libdir

%__make

%install
export XERCESCROOT=%_builddir/xerces-c-src_%{tarversion}

%make_install -C $XERCESCROOT/src/xercesc


%changelog
* Sun Dec 22 2024 pterjan <pterjan> 1:2.8.0-21.mga10
+ Revision: 2128327
- Rebuild for patchN deprecation

* Sat Mar 19 2022 umeabot <umeabot> 1:2.8.0-20.mga9
+ Revision: 1799495
- Mageia 9 Mass Rebuild

* Wed Jun 10 2020 daviddavid <daviddavid> 1:2.8.0-19.mga8
+ Revision: 1592047
- rebuild with new rpm-mageia-setup handling config.{guess,sub} update

* Fri Feb 14 2020 umeabot <umeabot> 1:2.8.0-17.mga8
+ Revision: 1518637
- Mageia 8 Mass Rebuild
+ wally <wally>
- replace deprecated %%setup_compile_flags

* Sun Sep 23 2018 umeabot <umeabot> 1:2.8.0-16.mga7
+ Revision: 1301846
- Mageia 7 Mass Rebuild

* Wed Jul 11 2018 wally <wally> 1:2.8.0-15.mga7
+ Revision: 1243114
- fix build on aarch64

* Sat Sep 02 2017 daviddavid <daviddavid> 1:2.8.0-14.mga7
+ Revision: 1150906
- use ours compile flags thus fixing empty debugsourcefiles.list

* Wed Mar 15 2017 mrambo3501 <mrambo3501> 1:2.8.0-13.mga6
+ Revision: 1092815
- Rebuild for icu-58.2

* Sat May 14 2016 shlomif <shlomif> 1:2.8.0-12.mga6
+ Revision: 1015250
- Rebuild for the new UCI (new major)

* Sat Feb 06 2016 umeabot <umeabot> 1:2.8.0-11.mga6
+ Revision: 940178
- Mageia 6 Mass Rebuild

* Wed Oct 15 2014 umeabot <umeabot> 1:2.8.0-10.mga5
+ Revision: 749200
- Second Mageia 5 Mass Rebuild

* Tue Sep 16 2014 umeabot <umeabot> 1:2.8.0-9.mga5
+ Revision: 690592
- Mageia 5 Mass Rebuild

* Fri Oct 18 2013 umeabot <umeabot> 1:2.8.0-8.mga4
+ Revision: 520505
- Mageia 4 Mass Rebuild

* Mon Jan 14 2013 umeabot <umeabot> 1:2.8.0-7.mga3
+ Revision: 386757
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Fri Oct 12 2012 fwang <fwang> 1:2.8.0-6.mga3
+ Revision: 304991
- cleanup spec

* Wed Apr 06 2011 tv <tv> 1:2.8.0-5.mga1
+ Revision: 81088
- cleanup
- imported package xerces-c28

